############################################
#Run all Maestro experiments as array jobs #
############################################


##################################################################################
#                                                                                #
# Copyright (C) 2018-2020 Cray Computer GmbH                                     #
# Copyright (C) 2021 HPE Switzerland GmbH                                        #
#                                                                                #
# Redistribution and use in source and binary forms, with or without             #
# modification, are permitted provided that the following conditions are         #
# met:                                                                           #
#                                                                                #
# 1. Redistributions of source code must retain the above copyright              #
#    notice, this list of conditions and the following disclaimer.               #
#                                                                                #
# 2. Redistributions in binary form must reproduce the above copyright           #
#    notice, this list of conditions and the following disclaimer in the         #
#    documentation and/or other materials provided with the distribution.        #
#                                                                                #
# 3. Neither the name of the copyright holder nor the names of its               #
#    contributors may be used to endorse or promote products derived from        #
#    this software without specific prior written permission.                    #
#                                                                                #
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS        #
# IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED          #
# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A                #
# PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT             #
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,         #
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT               #
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,          #
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY          #
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT            #
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE          #
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.           #
#                                                                                #
#                                                                                #
##################################################################################




"""
Piz Daint

local pool manager
python3 arrayJobGen.py -f /scratch/snx3000/amohamme/Maestro/clean-maestro/examples/core_bench.o  --nCDOThreads 10000 -N 1 --app multiInj --ranks 1 -o /scratch/snx3000/amohamme/Maestro/results/local_PM --sys daint --ht 0 --nJobs 18 --mstroPath /scratch/snx3000/amohamme/Maestro/install/lib

PM and producers
#... 1 node
python3 arrayJobGen.py --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/devel/maestro-core/examples/core_bench.o --app Maestro1 -N 2  --ranks 2 -o /scratch/snx3000/amohamme/Maestro/results/PM_producers/ --sys daint --ht 0 --nJobs 1 --mstroPath /scratch/snx3000/amohamme/Maestro/devel/install/lib
#... 2 node
python3 arrayJobGen.py --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/devel/maestro-core/examples/core_bench.o --app Maestro2 -N 3  --ranks 3 -o /scratch/snx3000/amohamme/Maestro/results/PM_producers/ --sys daint --ht 0 --nJobs 1 --mstroPath /scratch/snx3000/amohamme/Maestro/devel/install/lib
#... 4 node
python3 arrayJobGen.py --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/devel/maestro-core/examples/core_bench.o --app Maestro4 -N 5  --ranks 5 -o /scratch/snx3000/amohamme/Maestro/results/PM_producers/ --sys daint --ht 0 --nJobs 1 --mstroPath /scratch/snx3000/amohamme/Maestro/devel/install/lib
#... 8 node
python3 arrayJobGen.py --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/devel/maestro-core/examples/core_bench.o --app Maestro8 -N 9  --ranks 9 -o /scratch/snx3000/amohamme/Maestro/results/PM_producers/ --sys daint --ht 0 --nJobs 1 --mstroPath /scratch/snx3000/amohamme/Maestro/devel/install/lib
#... 16 node
python3 arrayJobGen.py --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/devel/maestro-core/examples/core_bench.o --app Maestro16 -N 17  --ranks 17 -o /scratch/snx3000/amohamme/Maestro/results/PM_producers/ --sys daint --ht 0 --nJob 1 --mstroPath /scratch/snx3000/amohamme/Maestro/devel/install/lib
#... 32 node
python3 arrayJobGen.py --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/devel/maestro-core/examples/core_bench.o --app Maestro32 -N 33  --ranks 33 -o /scratch/snx3000/amohamme/Maestro/results/PM_producers/ --sys daint --ht 0 --nJobs 1 --mstroPath /scratch/snx3000/amohamme/Maestro/devel/install/lib


#issue_136
PM and producers
#... 1 node
python3 arrayJobGen.py --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro1 -N 2  --ranks 2 -o /scratch/snx3000/amohamme/Maestro/issue_136/results/PM_producers/  --sys daint --ht 0 --nJobs 1 --mstroPath  /scratch/snx3000/amohamme/Maestro/issue_136/install/lib
#... 2 node
python3 arrayJobGen.py --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro2 -N 3  --ranks 3 -o /scratch/snx3000/amohamme/Maestro/issue_136/results/PM_producers/  --sys daint --ht 0 --nJobs 1 --mstroPath  /scratch/snx3000/amohamme/Maestro/issue_136/install/lib
#... 4 node
python3 arrayJobGen.py --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro4 -N 5  --ranks 5 -o  /scratch/snx3000/amohamme/Maestro/issue_136/results/PM_producers/  --sys daint --ht 0 --nJobs 1 --mstroPath   /scratch/snx3000/amohamme/Maestro/issue_136/install/lib
#... 8 node
python3 arrayJobGen.py --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro8 -N 9  --ranks 9 -o /scratch/snx3000/amohamme/Maestro/issue_136/results/PM_producers/  --sys daint --ht 0 --nJobs 1 --mstroPath   /scratch/snx3000/amohamme/Maestro/issue_136/install/lib
#... 16 node
python3 arrayJobGen.py --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro16 -N 17  --ranks 17 -o /scratch/snx3000/amohamme/Maestro/issue_136/results/PM_producers/  --sys daint --ht 0 --nJob 1 --mstroPath  /scratch/snx3000/amohamme/Maestro/issue_136/install/lib
#... 32 node
python3 arrayJobGen.py --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro32 -N 33  --ranks 33 -o  /scratch/snx3000/amohamme/Maestro/issue_136/results/PM_producers/  --sys daint --ht 0 --nJobs 1 --mstroPath  /scratch/snx3000/amohamme/Maestro/issue_136/install/lib
#... 64 node
python3 arrayJobGen.py --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro64 -N 65  --ranks 65 -o /scratch/snx3000/amohamme/Maestro/issue_136/results/PM_producers/  --sys daint --ht 0 --nJobs 1 --mstroPath  /scratch/snx3000/amohamme/Maestro/issue_136/install/lib
#... 96 node
python3 arrayJobGen.py --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro96 -N 97  --ranks 97 -o /scratch/snx3000/amohamme/Maestro/issue_136/results/PM_producers/  --sys daint --ht 0 --nJobs 1 --mstroPath  /scratch/snx3000/amohamme/Maestro/issue_136/install/lib


PM and producer and consumers -- 25 CDOs per thread is very large
#... 1 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro1 -N 3  --ranks 3 -o /scratch/snx3000/amohamme/Maestro/issue_136/results/PM_producers_consumers --sys daint --ht 0 --nJobs 1 --mstroPath /scratch/snx3000/amohamme/Maestro/issue_136/install/lib
#... 2 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro2 -N 4  --ranks 4 -o /scratch/snx3000/amohamme/Maestro/issue_136/results/PM_producers_consumers --sys daint --ht 0 --nJobs 1 --mstroPath /scratch/snx3000/amohamme/Maestro/issue_136/install/lib
#... 4 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro4 -N 6  --ranks 6 -o /scratch/snx3000/amohamme/Maestro/issue_136/results/PM_producers_consumers --sys daint --ht 0 --nJobs 1 --mstroPath /scratch/snx3000/amohamme/Maestro/issue_136/install/lib
#... 8 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro8 -N 10  --ranks 10 -o /scratch/snx3000/amohamme/Maestro/issue_136/results/PM_producers_consumers --sys daint --ht 0 --nJobs 1 --mstroPath /scratch/snx3000/amohamme/Maestro/issue_136/install/lib
#... 16 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro16 -N 18  --ranks 18 -o /scratch/snx3000/amohamme/Maestro/issue_136/results/PM_producers_consumers --sys daint --ht 0 --nJobs 1 --mstroPath /scratch/snx3000/amohamme/Maestro/issue_136/install/lib
#... 32 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro32 -N 34  --ranks 34 -o /scratch/snx3000/amohamme/Maestro/issue_136/results/PM_producers_consumers --sys daint --ht 0 --nJobs 1 --mstroPath /scratch/snx3000/amohamme/Maestro/issue_136/install/lib
#... 64 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro64 -N 66  --ranks 66 -o /scratch/snx3000/amohamme/Maestro/issue_136/results/PM_producers_consumers --sys daint --ht 0 --nJobs 1 --mstroPath /scratch/snx3000/amohamme/Maestro/issue_136/install/lib
#... 96 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 25  -f /scratch/snx3000/amohamme/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro96 -N 98  --ranks 98 -o /scratch/snx3000/amohamme/Maestro/issue_136/results/PM_producers_consumers --sys daint --ht 0 --nJobs 1 --mstroPath /scratch/snx3000/amohamme/Maestro/issue_136/install/lib





Sage

local pool manager
python3 arrayJobGen.py -f /home/users/jusers/mohammed1/sage/clean-maestro/examples/core_bench.o  --nCDOThreads 10000 -N 1 --app local --ranks 1 -o /home/users/jusers/mohammed1/sage/results/local_PM --sys sage --ht 0 --nJobs 18 --mstroPath /home/users/jusers/mohammed1/sage/install/lib

PM and producers
#... 1 node
python3 arrayJobGen.py --nCDOThreads 25  -f /home/users/jusers/mohammed1/sage/clean-maestro/examples/core_bench.o --app Maestro1 -N 2  --ranks 2 -o /home/users/jusers/mohammed1/sage/results/PM_producers/ --sys sage --ht 0 --nJobs 18 --mstroPath /home/users/jusers/mohammed1/sage/install/lib
#... 2 node
python3 arrayJobGen.py --nCDOThreads 25  -f /home/users/jusers/mohammed1/sage/clean-maestro/examples/core_bench.o --app Maestro2 -N 3  --ranks 3 -o /home/users/jusers/mohammed1/sage/results/PM_producers/ --sys sage --ht 0 --nJobs 18 --mstroPath /home/users/jusers/mohammed1/sage/install/lib
#... 4 node
python3 arrayJobGen.py --nCDOThreads 25  -f /home/users/jusers/mohammed1/sage/clean-maestro/examples/core_bench.o --app Maestro4 -N 5  --ranks 5 -o /home/users/jusers/mohammed1/sage/results/PM_producers/ --sys sage --ht 0 --nJobs 18 --mstroPath /home/users/jusers/mohammed1/sage/install/lib
#... 7 node
python3 arrayJobGen.py --nCDOThreads 25  -f /home/users/jusers/mohammed1/sage/clean-maestro/examples/core_bench.o --app Maestro8 -N 8  --ranks 8 -o /home/users/jusers/mohammed1/sage/results/PM_producers/ --sys sage --ht 0 --nJobs 18 --mstroPath /home/users/jusers/mohammed1/sage/install/lib


PM and producers and consumers
#... 1 node
python3 arrayJobGen.py  --nConsumers 1 --consumerMode sinkall --nCDOThreads 25  -f /home/users/jusers/mohammed1/sage/clean-maestro/examples/core_bench.o --app Maestro1 -N 3  --ranks 3 -o /home/users/jusers/mohammed1/sage/results/PM_producers_consumers/ --sys sage --ht 0 --nJobs 18 --mstroPath /home/users/jusers/mohammed1/sage/install/lib
#... 2 node
python3 arrayJobGen.py  --nConsumers 1 --consumerMode sinkall --nCDOThreads 25  -f /home/users/jusers/mohammed1/sage/clean-maestro/examples/core_bench.o --app Maestro2 -N 4  --ranks 4 -o /home/users/jusers/mohammed1/sage/results/PM_producers_consumers/ --sys sage --ht 0 --nJobs 18 --mstroPath /home/users/jusers/mohammed1/sage/install/lib
#... 4 node
python3 arrayJobGen.py  --nConsumers 1 --consumerMode sinkall --nCDOThreads 25  -f /home/users/jusers/mohammed1/sage/clean-maestro/examples/core_bench.o --app Maestro4 -N 6  --ranks 6 -o /home/users/jusers/mohammed1/sage/results/PM_producers_consumers/ --sys sage --ht 0 --nJobs 18 --mstroPath /home/users/jusers/mohammed1/sage/install/lib



Jupiter

local pool manager
python3 arrayJobGen.py -f /lus/snx11108/mohammal/clean-maestro/examples/wrapper.sh  --nCDOThreads 10000 -N 1 --app local --ranks 1 -o /lus/snx11108/mohammal/results/local_PM --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/install/lib

PM and producers
#... 1 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/snx11108/mohammal/clean-maestro/examples_k/wrapper.sh --app Maestro1 -N 2  --ranks 2 -o /lus/snx11108/mohammal/results/PM_producers/ --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/install/lib
#... 2 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/snx11108/mohammal/clean-maestro/examples_k/wrapper.sh --app Maestro2 -N 3  --ranks 3 -o /lus/snx11108/mohammal/results/PM_producers/ --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/install/lib
#... 4 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/snx11108/mohammal/clean-maestro/examples_k/wrapper.sh --app Maestro4 -N 5  --ranks 5 -o /lus/snx11108/mohammal/results/PM_producers/ --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/install/lib
#... 8 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/snx11108/mohammal/clean-maestro/examples_k/wrapper.sh --app Maestro8 -N 9  --ranks 9 -o /lus/snx11108/mohammal/results/PM_producers/ --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/install/lib
#... 16 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/snx11108/mohammal/clean-maestro/examples_k/wrapper.sh --app Maestro16 -N 17  --ranks 17 -o /lus/snx11108/mohammal/results/PM_producers/ --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/install/lib
#... 32 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/snx11108/mohammal/clean-maestro/examples_k/wrapper.sh --app Maestro32 -N 32  --ranks 32 -o /lus/snx11108/mohammal/results/PM_producers/ --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/install/lib

issue_136
PM and producers
#... 1 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/snx11108/mohammal/Maestro/issue_136/maestro-core/examples/wrapper.sh --app Maestro1 -N 2     --ranks 2 -o /lus/snx11108/mohammal/Maestro/issue_136/results/PM_producers/ --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/Maestro/issue_136/install/lib
#... 2 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/snx11108/mohammal/Maestro/issue_136/maestro-core/examples/wrapper.sh --app Maestro2 -N 3     --ranks 3 -o /lus/snx11108/mohammal/Maestro/issue_136/results/PM_producers/ --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/Maestro/issue_136/install/lib
#... 4 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/snx11108/mohammal/Maestro/issue_136/maestro-core/examples/wrapper.sh --app Maestro4 -N 5     --ranks 5 -o /lus/snx11108/mohammal/Maestro/issue_136/results/PM_producers/ --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/Maestro/issue_136/install/lib
#... 8 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/snx11108/mohammal/Maestro/issue_136/maestro-core/examples/wrapper.sh --app Maestro8 -N 9     --ranks 9 -o /lus/snx11108/mohammal/Maestro/issue_136/results/PM_producers/ --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/Maestro/issue_136/install/lib
#... 16 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/snx11108/mohammal/Maestro/issue_136/maestro-core/examples/wrapper.sh --app Maestro16 -N 17  --ranks 17 -o /lus/snx11108/mohammal/Maestro/issue_136/results/PM_producers/ --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/Maestro/issue_136/install/lib
#... 32 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/snx11108/mohammal/Maestro/issue_136/maestro-core/examples/wrapper.sh --app Maestro32 -N 32  --ranks 32 -o /lus/snx11108/mohammal/Maestro/issue_136/results/PM_producers/ --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/Maestro/issue_136/install/lib



PM and producer and consumers -- 25 CDOs per thread is very large
#... 1 node
python3 arrayJobGen.py -k 16 --nConsumers 1 --consumerMode sinkall --nCDOThreads 15  -f /lus/snx11108/mohammal/clean-maestro/examples_k/wrapper.sh --app Maestro1 -N 3  --ranks 3 -o /lus/snx11108/mohammal/results/PM_producers_consumers --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/install/lib

#... 2 node
python3 arrayJobGen.py -k 16 --nConsumers 1 --consumerMode sinkall --nCDOThreads 15  -f /lus/snx11108/mohammal/clean-maestro/examples_k/wrapper.sh --app Maestro2 -N 4  --ranks 4 -o /lus/snx11108/mohammal/results/PM_producers_consumers --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/install/lib

#... 4 node
python3 arrayJobGen.py -k 16 --nConsumers 1 --consumerMode sinkall --nCDOThreads 15  -f /lus/snx11108/mohammal/clean-maestro/examples_k/wrapper.sh --app Maestro4 -N 6  --ranks 6 -o /lus/snx11108/mohammal/results/PM_producers_consumers --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/install/lib

#... 8 node
python3 arrayJobGen.py -k 16 --nConsumers 1 --consumerMode sinkall --nCDOThreads 15  -f /lus/snx11108/mohammal/clean-maestro/examples_k/wrapper.sh --app Maestro8 -N 10  --ranks 10 -o /lus/snx11108/mohammal/results/PM_producers_consumers --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/install/lib

#... 16 node
python3 arrayJobGen.py -k 16 --nConsumers 1 --consumerMode sinkall --nCDOThreads 15  -f /lus/snx11108/mohammal/clean-maestro/examples_k/wrapper.sh --app Maestro16 -N 18  --ranks 18 -o /lus/snx11108/mohammal/results/PM_producers_consumers --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/install/lib

#... 32 node
python3 arrayJobGen.py -k 16 --nConsumers 1 --consumerMode sinkall --nCDOThreads 15  -f /lus/snx11108/mohammal/clean-maestro/examples_k/wrapper.sh --app Maestro32 -N 32  --ranks 32 -o /lus/snx11108/mohammal/results/PM_producers_consumers --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/install/lib


issue_136
#... 1 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 15  -f /lus/snx11108/mohammal/Maestro/issue_136/maestro-core/examples/wrapper.sh --app Maestro1 -N 3  --ranks 3 -o /lus/snx11108/mohammal/Maestro/issue_136/results/PM_producers_consumers --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/Maestro/issue_136/install/lib

#... 2 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 15  -f /lus/snx11108/mohammal/Maestro/issue_136/maestro-core/examples/wrapper.sh --app Maestro2 -N 4  --ranks 4 -o /lus/snx11108/mohammal/Maestro/issue_136/results/PM_producers_consumers --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/Maestro/issue_136/install/lib

#... 4 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 15  -f /lus/snx11108/mohammal/Maestro/issue_136/maestro-core/examples/wrapper.sh --app Maestro4 -N 6  --ranks 6 -o /lus/snx11108/mohammal/Maestro/issue_136/results/PM_producers_consumers --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/Maestro/issue_136/install/lib

#... 8 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 15  -f /lus/snx11108/mohammal/Maestro/issue_136/maestro-core/examples/wrapper.sh --app Maestro8 -N 10  --ranks 10 -o /lus/snx11108/mohammal/Maestro/issue_136/results/PM_producers_consumers --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/Maestro/issue_136/install/lib

#... 16 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 15  -f /lus/snx11108/mohammal/Maestro/issue_136/maestro-core/examples/wrapper.sh --app Maestro16 -N 18  --ranks 18 -o /lus/snx11108/mohammal/Maestro/issue_136/results/PM_producers_consumers --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/Maestro/issue_136/install/lib

#... 32 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 15  -f /lus/snx11108/mohammal/Maestro/issue_136/maestro-core/examples/wrapper.sh --app Maestro32 -N 32  --ranks 32 -o /lus/snx11108/mohammal/Maestro/issue_136/results/PM_producers_consumers --sys jupiter --ht 0 --nJobs 1 --mstroPath /lus/snx11108/mohammal/Maestro/issue_136/install/lib



pinot

local pool manager
python3 arrayJobGen.py -f /lus/cls01075/mohammal/Maestro/maestro-core/examples/core_bench.o  --nCDOThreads 10000 -N 1 --app local --ranks 1 -o /lus/cls01075/mohammal/Maestro/results/local_PM --sys pinot --ht 0 --nJobs 18 --mstroPath /lus/cls01075/mohammal/install/lib

PM and producers
#... 1 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/cls01075/mohammal/Maestro/user_defined_attributes/examples/core_bench.o --app Maestro1 -N 2  --ranks 2 -o /lus/cls01075/mohammal/Maestro/results/PM_producers/ --sys pinot --ht 0 --nJobs 18 --mstroPath /lus/cls01075/mohammal/install/lib
#... 2 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/cls01075/mohammal/Maestro/user_defined_attributes/examples/core_bench.o --app Maestro2 -N 3  --ranks 3 -o /lus/cls01075/mohammal/Maestro/results/PM_producers/ --sys pinot --ht 0 --nJobs 18 --mstroPath /lus/cls01075/mohammal/install/lib
#... 4 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/cls01075/mohammal/Maestro/user_defined_attributes/examples/core_bench.o --app Maestro4 -N 5  --ranks 5 -o /lus/cls01075/mohammal/Maestro/results/PM_producers/ --sys pinot --ht 0 --nJobs 18 --mstroPath /lus/cls01075/mohammal/install/lib
#... 8 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/cls01075/mohammal/Maestro/user_defined_attributes/examples/core_bench.o --app Maestro8 -N 9  --ranks 9 -o /lus/cls01075/mohammal/Maestro/results/PM_producers/ --sys pinot --ht 0 --nJobs 18 --mstroPath /lus/cls01075/mohammal/install/lib
#... 16 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/cls01075/mohammal/Maestro/user_defined_attributes/examples/core_bench.o --app Maestro16 -N 17  --ranks 17 -o /lus/cls01075/mohammal/Maestro/results/PM_producers/ --sys pinot --ht 0 --nJobs 18 --mstroPath /lus/cls01075/mohammal/install/lib
#... 32 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/cls01075/mohammal/Maestro/user_defined_attributes/examples/core_bench.o --app Maestro32 -N 33  --ranks 33 -o /lus/cls01075/mohammal/Maestro/results/PM_producers/ --sys pinot --ht 0 --nJobs 18 --mstroPath /lus/cls01075/mohammal/install/lib



#issue_136
#... 1 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro1 -N 2  --ranks 2 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers/ --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 2 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro2 -N 3  --ranks 3 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers/ --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 4 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro4 -N 5  --ranks 5 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers/ --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 8 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro8 -N 9  --ranks 9 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers/ --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 16 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro16 -N 17  --ranks 17 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers/ --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 32 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro32 -N 33  --ranks 33 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers/ --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 64 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro64 -N 65  --ranks 65 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers/ --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 96 node
python3 arrayJobGen.py --nCDOThreads 25  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro96 -N 97  --ranks 97 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers/ --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib


issue_136
PM and producer and consumers -- 25 CDOs per thread is very large
#... 1 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro1 -N 3  --ranks 3 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 2 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro2 -N 4  --ranks 4 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 4 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench  --app Maestro4 -N 6  --ranks 6 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/   --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 8 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro8 -N 10  --ranks 10 -o  /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 16 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro16 -N 18  --ranks 18 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 32 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro32 -N 34  --ranks 34 -o  /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 64 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro64 -N 66  --ranks 66 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath  /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 96 node
python3 arrayJobGen.py --nConsumers 1 --consumerMode sinkall --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro96 -N 98  --ranks 98 -o  /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/ --sys pinot --ht 0 --nJobs 1 --mstroPath  /lus/cls01075/mohammal/Maestro/issue_136/install/lib



PM and producer and consumers -- 25 CDOs per thread is very large
#... 1 node
python3 arrayJobGen.py --nConsumers 1  --consumerMode one2one --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro1   -N 3  --ranks 3  -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 2 node
python3 arrayJobGen.py --nConsumers 2  --consumerMode one2one --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro2   -N 5  --ranks 5  -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 4 node
python3 arrayJobGen.py --nConsumers 4  --consumerMode one2one --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench  --app Maestro4  -N 9  --ranks 9  -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/   --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 8 node
python3 arrayJobGen.py --nConsumers 8  --consumerMode one2one --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro8  -N 17  --ranks 17 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 16 node
python3 arrayJobGen.py --nConsumers 16 --consumerMode one2one --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro16 -N 33  --ranks 33 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 32 node
python3 arrayJobGen.py --nConsumers 32 --consumerMode one2one --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro32 -N 65  --ranks 65 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib


PM and producer and consumers -- 25 CDOs per thread is very large
#... 1 node
python3 arrayJobGen.py --nConsumers 1  --consumerMode one2ten --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro1   -N 12  --ranks 12  -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 2 node
python3 arrayJobGen.py --nConsumers 2  --consumerMode one2ten --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro2   -N 23  --ranks 23  -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 3 node
python3 arrayJobGen.py --nConsumers 3  --consumerMode one2ten --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench  --app Maestro3  -N 34  --ranks 34  -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/   --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 4 node
python3 arrayJobGen.py --nConsumers 4  --consumerMode one2ten --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro4  -N 45  --ranks 45 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 5 node
python3 arrayJobGen.py --nConsumers 5 --consumerMode one2ten --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro5 -N 56  --ranks 56 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 6 node
python3 arrayJobGen.py --nConsumers 6 --consumerMode one2ten --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro6 -N 67  --ranks 67 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 7 node
python3 arrayJobGen.py --nConsumers 7 --consumerMode one2ten --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro7 -N 78  --ranks 78 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 8 node
python3 arrayJobGen.py --nConsumers 8 --consumerMode one2ten --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro8 -N 89  --ranks 89 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib
#... 9 node
python3 arrayJobGen.py --nConsumers 9 --consumerMode one2ten --nCDOThreads 10  -f /lus/cls01075/mohammal/Maestro/issue_136/maestro-core/examples/core_bench --app Maestro9 -N 100  --ranks 100 -o /lus/cls01075/mohammal/Maestro/issue_136/results/PM_producers_consumers/  --sys pinot --ht 0 --nJobs 1 --mstroPath /lus/cls01075/mohammal/Maestro/issue_136/install/lib



"""

#nConsumers and consumerMode are important inputs for transport tests

import os
from optparse import OptionParser
import arrayJobHelper as helper


parser = OptionParser()
parser.add_option("-f", "--file", dest="exPath",
                  help="data file path", default=".",  metavar="FILE")

parser.add_option("-N", dest="nodes",
                  help="number of nodes", default=1,  metavar="N")

parser.add_option("--app", dest="app",
                  help="app name", default=8,  metavar="APP")

parser.add_option("--ranks", dest="ranks",
                  help="Number of RANK", default=1,  metavar="NUMBEROFRANKS")

parser.add_option("-t", dest="threads",
                  help="threads per rank", default=20,  metavar="THREAD")

parser.add_option("-o", dest="outPath",
                  help="Output folder path", default=".",  metavar="OUTPUT")


parser.add_option("--ht", dest="ht",
                  help="enables/disbales hyperthreading", default="0",  metavar="HT")

parser.add_option("--sys", dest="sys",
                  help="system name", default="xeon",  metavar="Partition")

parser.add_option("--nJobs", dest="nJobs",
                  help="Number of concurrent jobs", default="100",  metavar="JOBLIMIT")

parser.add_option("--nCDOThreads", dest="nCDOThreads",
                  help="Number of CDOs per thread", default=25,  metavar="nCDOThreads")


parser.add_option("--mstroPath", dest="mstroPath",
                  help="Path to Maestro install directory", default=".",  metavar="mstroPath")

parser.add_option("--nConsumers", dest="nConsumers",
                  help="Number of consumer ranks", default="0",  metavar="nConsumers")

parser.add_option("--consumerMode", dest="consumerMode",
                  help="sinkall, one2one, one2ten, or all2all", default="sinkall",  metavar="consumerMode")

parser.add_option("--jobTime", dest="jobTime",
                  help="Time limit for a single job, please increase in Piz Daint", default="1:30:00",  metavar="jobtime")

parser.add_option("-k", dest="k",
                  help="repeititions wihtin one job", default="1",  metavar="k")


(options, args) = parser.parse_args()

#repeats = [0,1,2,3,4]
repeats = [0]


nExperiments = 0

# commands file to run the application with the correct parameters
filename = 'job_'+options.app


#if using more than one node, only use the maximum num of threads ...otherwise, scan through all possible thread counts within node.
if int(options.nodes) > 1:
      nThreads = [helper.getMaxThreads(options.sys, ht=int(options.ht))]
      #if int(options.nConsumers) > 0:
      #  nThreads = [1]
else:
      nThreads = helper.calculatenThreads(options.sys, ht=int(options.ht))
#
fabrics = helper.fiProviders[options.sys]

if int(options.nConsumers) == 0:
    transport = [helper.transport[options.sys][0]] #default
    nAttributes = helper.nAttributes
    sizeAttributes = helper.sizeAttributes
    sizeCDOs = [0]
else:
    transport = helper.transport[options.sys]
    nAttributes = [0]
    sizeAttributes = [0]
    sizeCDOs = helper.sizeCDOs

#print(transport)

nProducers = 1
# if we are using more than one node, then
if int(options.nodes) > 1:
      nProducers = int(options.nodes) - 1 - int(options.nConsumers)


#number of producer threads
nProducers = [i * nProducers for i in nThreads]


#maybe loop over the transport methods from here
nExperiments += helper.createCommandFile(filename, nAttributes, sizeAttributes, nThreads, options.exPath, repeats, fabrics, int(options.nConsumers), sizeCDOs, transport, int(options.nCDOThreads))



print("#experiments = " + str(nExperiments))

#output file names to redirect the output to the correct file
nExperiments = helper.createOutputfilenamesFile(filename, nAttributes, sizeAttributes, nProducers, repeats, options.outPath, int(options.nCDOThreads), fabrics, int(options.nConsumers), sizeCDOs, transport)

#print("#experiments = " + str(nExperiments))

#export file to export env ?? needed for the FI_PROVIDER=sockets or others and transport layer
nExperiments = helper.createExportFile(filename, nAttributes, sizeAttributes, nThreads, repeats, fabrics, transport, sizeCDOs, filemode="w")

#print("#experiments = " + str(nExperiments))
# batch array job file
#please be aware to increase the job time on slower systems, such as Piz Daint
helper.createSlurmBatchJob(filename, options.app, int(options.nodes), int(options.ranks), nExperiments, options.sys, options.mstroPath, options.consumerMode, ht=int(options.ht), jobLimit=int(options.nJobs), time=options.jobTime, k=int(options.k), filemode="w")



#sbatch filename
# os.system("sbatch "+filename)
